//svmsgmpx2q/server.
#include <signal.h>
#include "mesg_send.c"
#include "mesg_recv.c"
#include "sigchldwaitpid.c"
void
server(int readid, int writeid)
{
FILE *fp; 
char *ptr;
ssize_t n;
struct mymesg mesg;
void sig_chld(int);
signal(SIGCHLD, sig_chld);
for ( ; ; ) {
/*      */
mesg.mesg_type = 1;
if ((n = mesg_recv(readid, &mesg)) == 0) {
printf("pathname missing\n");
continue;
}
mesg.mesg_data[n]='\0'; /*   */
if ( (ptr = strchr(mesg.mesg_data, ' ')) == NULL) {
printf("bogus request: %s\n", mesg.mesg_data);
continue;
}
*ptr++ = 0; /* ptr =   */
writeid = atol(mesg.mesg_data);
printf("   %d\n",writeid);
printf("  %s\n",ptr);
if (fork() == 0) { /*   */
if ( (fp = fopen(ptr, "r")) == NULL) {
/* :    */
snprintf(mesg.mesg_data+n, sizeof(mesg.mesg_data) - n,": can't open %s\n", strerror(errno));
mesg.mesg_len = strlen(ptr);
memmove(mesg.mesg_data, ptr, mesg.mesg_len);
mesg_send(writeid, &mesg);
} else {
/*  ,   */
printf("  %ld\n",getpid());
while (fgets(mesg.mesg_data, MAXMESGDATA, fp)!=NULL){
mesg.mesg_len = strlen(mesg.mesg_data);
mesg_send(writeid, &mesg);
}
fclose(fp);
}
/*   ,    */
mesg.mesg_len = 0;
mesg_send(writeid, &mesg);
exit(0);	/*    */
}
/*     */
}
}
